Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/tesselation.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -1709,181 +2456,316 @@
  * @param *LC LinkedCell structure with neighbouring points
  */
-bool Tesselation::FindNextSuitableTriangle(BoundaryLineSet &Line, BoundaryTriangleSet &T, const double& RADIUS, const LinkedCell *LC)
-{
-  Log() << Verbose(0) << "Begin of FindNextSuitableTriangle\n";
-  bool result = true;
-  CandidateList *OptCandidates = new CandidateList();
-
+bool Tesselation::FindNextSuitableTriangle(CandidateForTesselation &CandidateLine, const BoundaryTriangleSet &T, const double& RADIUS, const LinkedCell *LC)
+{
+  Info FunctionInfo(__func__);
   Vector CircleCenter;
   Vector CirclePlaneNormal;
-  Vector OldSphereCenter;
+  Vector RelativeSphereCenter;
   Vector SearchDirection;
   Vector helper;
-  TesselPoint *ThirdNode = NULL;
+  BoundaryPointSet *ThirdPoint = NULL;
   LineMap::iterator testline;
-  double ShortestAngle = 2.*M_PI; // This will indicate the quadrant.
   double radius, CircleRadius;
 
-  Log() << Verbose(1) << "Current baseline is " << Line << " of triangle " << T << "." << endl;
-  for (int i=0;i<3;i++)
-    if ((T.endpoints[i]->node != Line.endpoints[0]->node) && (T.endpoints[i]->node != Line.endpoints[1]->node))
-      ThirdNode = T.endpoints[i]->node;
+  for (int i = 0; i < 3; i++)
+    if ((T.endpoints[i] != CandidateLine.BaseLine->endpoints[0]) && (T.endpoints[i] != CandidateLine.BaseLine->endpoints[1])) {
+      ThirdPoint = T.endpoints[i];
+      break;
+    }
+  DoLog(0) && (Log() << Verbose(0) << "Current baseline is " << *CandidateLine.BaseLine << " with ThirdPoint " << *ThirdPoint << " of triangle " << T << "." << endl);
+
+  CandidateLine.T = &T;
 
   // construct center of circle
-  CircleCenter.CopyVector(Line.endpoints[0]->node->node);
-  CircleCenter.AddVector(Line.endpoints[1]->node->node);
+  CircleCenter.CopyVector(CandidateLine.BaseLine->endpoints[0]->node->node);
+  CircleCenter.AddVector(CandidateLine.BaseLine->endpoints[1]->node->node);
   CircleCenter.Scale(0.5);
 
   // construct normal vector of circle
-  CirclePlaneNormal.CopyVector(Line.endpoints[0]->node->node);
-  CirclePlaneNormal.SubtractVector(Line.endpoints[1]->node->node);
+  CirclePlaneNormal.CopyVector(CandidateLine.BaseLine->endpoints[0]->node->node);
+  CirclePlaneNormal.SubtractVector(CandidateLine.BaseLine->endpoints[1]->node->node);
 
   // calculate squared radius of circle
   radius = CirclePlaneNormal.ScalarProduct(&CirclePlaneNormal);
-  if (radius/4. < RADIUS*RADIUS) {
-    CircleRadius = RADIUS*RADIUS - radius/4.;
+  if (radius / 4. < RADIUS * RADIUS) {
+    // construct relative sphere center with now known CircleCenter
+    RelativeSphereCenter.CopyVector(&T.SphereCenter);
+    RelativeSphereCenter.SubtractVector(&CircleCenter);
+
+    CircleRadius = RADIUS * RADIUS - radius / 4.;
     CirclePlaneNormal.Normalize();
-    //Log() << Verbose(2) << "INFO: CircleCenter is at " << CircleCenter << ", CirclePlaneNormal is " << CirclePlaneNormal << " with circle radius " << sqrt(CircleRadius) << "." << endl;
-
-    // construct old center
-    GetCenterofCircumcircle(&OldSphereCenter, *T.endpoints[0]->node->node, *T.endpoints[1]->node->node, *T.endpoints[2]->node->node);
-    helper.CopyVector(&T.NormalVector);  // normal vector ensures that this is correct center of the two possible ones
-    radius = Line.endpoints[0]->node->node->DistanceSquared(&OldSphereCenter);
-    helper.Scale(sqrt(RADIUS*RADIUS - radius));
-    OldSphereCenter.AddVector(&helper);
-    OldSphereCenter.SubtractVector(&CircleCenter);
-    //Log() << Verbose(2) << "INFO: OldSphereCenter is at " << OldSphereCenter << "." << endl;
-
-    // construct SearchDirection
-    SearchDirection.MakeNormalVector(&T.NormalVector, &CirclePlaneNormal);
-    helper.CopyVector(Line.endpoints[0]->node->node);
-    helper.SubtractVector(ThirdNode->node);
+    DoLog(1) && (Log() << Verbose(1) << "INFO: CircleCenter is at " << CircleCenter << ", CirclePlaneNormal is " << CirclePlaneNormal << " with circle radius " << sqrt(CircleRadius) << "." << endl);
+
+    DoLog(1) && (Log() << Verbose(1) << "INFO: OldSphereCenter is at " << T.SphereCenter << "." << endl);
+
+    // construct SearchDirection and an "outward pointer"
+    SearchDirection.MakeNormalVector(&RelativeSphereCenter, &CirclePlaneNormal);
+    helper.CopyVector(&CircleCenter);
+    helper.SubtractVector(ThirdPoint->node->node);
     if (helper.ScalarProduct(&SearchDirection) < -HULLEPSILON)// ohoh, SearchDirection points inwards!
       SearchDirection.Scale(-1.);
-    SearchDirection.ProjectOntoPlane(&OldSphereCenter);
-    SearchDirection.Normalize();
-    Log() << Verbose(2) << "INFO: SearchDirection is " << SearchDirection << "." << endl;
-    if (fabs(OldSphereCenter.ScalarProduct(&SearchDirection)) > HULLEPSILON) {
+    DoLog(1) && (Log() << Verbose(1) << "INFO: SearchDirection is " << SearchDirection << "." << endl);
+    if (fabs(RelativeSphereCenter.ScalarProduct(&SearchDirection)) > HULLEPSILON) {
       // rotated the wrong way!
-      eLog() << Verbose(0) << "ERROR: SearchDirection and RelativeOldSphereCenter are still not orthogonal!" << endl;
+      DoeLog(1) && (eLog() << Verbose(1) << "SearchDirection and RelativeOldSphereCenter are still not orthogonal!" << endl);
     }
 
     // add third point
-    FindThirdPointForTesselation(T.NormalVector, SearchDirection, OldSphereCenter, &Line, ThirdNode, OptCandidates, &ShortestAngle, RADIUS, LC);
+    FindThirdPointForTesselation(T.NormalVector, SearchDirection, T.SphereCenter, CandidateLine, ThirdPoint, RADIUS, LC);
 
   } else {
-    Log() << Verbose(1) << "Circumcircle for base line " << Line << " and base triangle " << T << " is too big!" << endl;
-  }
-
-  if (OptCandidates->begin() == OptCandidates->end()) {
-    eLog() << Verbose(0) << "WARNING: Could not find a suitable candidate." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Circumcircle for base line " << *CandidateLine.BaseLine << " and base triangle " << T << " is too big!" << endl);
+  }
+
+  if (CandidateLine.pointlist.empty()) {
+    DoeLog(2) && (eLog() << Verbose(2) << "Could not find a suitable candidate." << endl);
     return false;
   }
-  Log() << Verbose(1) << "Third Points are ";
-  for (CandidateList::iterator it = OptCandidates->begin(); it != OptCandidates->end(); ++it) {
-    Log() << Verbose(0) << " " << *(*it)->point;
-  }
-  Log() << Verbose(0) << endl;
-
-  BoundaryLineSet *BaseRay = &Line;
-  for (CandidateList::iterator it = OptCandidates->begin(); it != OptCandidates->end(); ++it) {
-    Log() << Verbose(1) << " Third point candidate is " << *(*it)->point
-    << " with circumsphere's center at " << (*it)->OptCenter << "." << endl;
-    Log() << Verbose(1) << " Baseline is " << *BaseRay << endl;
-
-    // check whether all edges of the new triangle still have space for one more triangle (i.e. TriangleCount <2)
-    TesselPoint *PointCandidates[3];
-    PointCandidates[0] = (*it)->point;
-    PointCandidates[1] = BaseRay->endpoints[0]->node;
-    PointCandidates[2] = BaseRay->endpoints[1]->node;
-    int existentTrianglesCount = CheckPresenceOfTriangle(PointCandidates);
-
-    BTS = NULL;
-    // If there is no triangle, add it regularly.
-    if (existentTrianglesCount == 0) {
-      AddTesselationPoint((*it)->point, 0);
-      AddTesselationPoint(BaseRay->endpoints[0]->node, 1);
-      AddTesselationPoint(BaseRay->endpoints[1]->node, 2);
-
-      if (CheckLineCriteriaForDegeneratedTriangle((const BoundaryPointSet ** const )TPS)) {
-        AddTesselationLine(TPS[0], TPS[1], 0);
-        AddTesselationLine(TPS[0], TPS[2], 1);
-        AddTesselationLine(TPS[1], TPS[2], 2);
-
-        BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
-        AddTesselationTriangle();
-        (*it)->OptCenter.Scale(-1.);
-        BTS->GetNormalVector((*it)->OptCenter);
-        (*it)->OptCenter.Scale(-1.);
-
-        Log() << Verbose(0) << "--> New triangle with " << *BTS << " and normal vector " << BTS->NormalVector
-          << " for this triangle ... " << endl;
-      //Log() << Verbose(1) << "We have "<< TrianglesOnBoundaryCount << " for line " << *BaseRay << "." << endl;
-      } else {
-        Log() << Verbose(1) << "WARNING: This triangle consisting of ";
-        Log() << Verbose(0) << *(*it)->point << ", ";
-        Log() << Verbose(0) << *BaseRay->endpoints[0]->node << " and ";
-        Log() << Verbose(0) << *BaseRay->endpoints[1]->node << " ";
-        Log() << Verbose(0) << "exists and is not added, as it does not seem helpful!" << endl;
-        result = false;
+  DoLog(0) && (Log() << Verbose(0) << "Third Points are: " << endl);
+  for (TesselPointList::iterator it = CandidateLine.pointlist.begin(); it != CandidateLine.pointlist.end(); ++it) {
+    DoLog(0) && (Log() << Verbose(0) << " " << *(*it) << endl);
+  }
+
+  return true;
+}
+;
+
+/** Walks through Tesselation::OpenLines() and finds candidates for newly created ones.
+ * \param *&LCList atoms in LinkedCell list
+ * \param RADIUS radius of the virtual sphere
+ * \return true - for all open lines without candidates so far, a candidate has been found,
+ *         false - at least one open line without candidate still
+ */
+bool Tesselation::FindCandidatesforOpenLines(const double RADIUS, const LinkedCell *&LCList)
+{
+  bool TesselationFailFlag = true;
+  CandidateForTesselation *baseline = NULL;
+  BoundaryTriangleSet *T = NULL;
+
+  for (CandidateMap::iterator Runner = OpenLines.begin(); Runner != OpenLines.end(); Runner++) {
+    baseline = Runner->second;
+    if (baseline->pointlist.empty()) {
+      assert((baseline->BaseLine->triangles.size() == 1) && ("Open line without exactly one attached triangle"));
+      T = (((baseline->BaseLine->triangles.begin()))->second);
+      DoLog(1) && (Log() << Verbose(1) << "Finding best candidate for open line " << *baseline->BaseLine << " of triangle " << *T << endl);
+      TesselationFailFlag = TesselationFailFlag && FindNextSuitableTriangle(*baseline, *T, RADIUS, LCList); //the line is there, so there is a triangle, but only one.
+    }
+  }
+  return TesselationFailFlag;
+}
+;
+
+/** Adds the present line and candidate point from \a &CandidateLine to the Tesselation.
+ * \param CandidateLine triangle to add
+ * \param RADIUS Radius of sphere
+ * \param *LC LinkedCell structure
+ * \NOTE we need the copy operator here as the original CandidateForTesselation is removed in
+ * AddTesselationLine() in AddCandidateTriangle()
+ */
+void Tesselation::AddCandidatePolygon(CandidateForTesselation CandidateLine, const double RADIUS, const LinkedCell *LC)
+{
+  Info FunctionInfo(__func__);
+  Vector Center;
+  TesselPoint * const TurningPoint = CandidateLine.BaseLine->endpoints[0]->node;
+  TesselPointList::iterator Runner;
+  TesselPointList::iterator Sprinter;
+
+  // fill the set of neighbours
+  TesselPointSet SetOfNeighbours;
+  SetOfNeighbours.insert(CandidateLine.BaseLine->endpoints[1]->node);
+  for (TesselPointList::iterator Runner = CandidateLine.pointlist.begin(); Runner != CandidateLine.pointlist.end(); Runner++)
+    SetOfNeighbours.insert(*Runner);
+  TesselPointList *connectedClosestPoints = GetCircleOfSetOfPoints(&SetOfNeighbours, TurningPoint, CandidateLine.BaseLine->endpoints[1]->node->node);
+
+  DoLog(0) && (Log() << Verbose(0) << "List of Candidates for Turning Point " << *TurningPoint << ":" << endl);
+  for (TesselPointList::iterator TesselRunner = connectedClosestPoints->begin(); TesselRunner != connectedClosestPoints->end(); ++TesselRunner)
+    DoLog(0) && (Log() << Verbose(0) << " " << **TesselRunner << endl);
+
+  // go through all angle-sorted candidates (in degenerate n-nodes case we may have to add multiple triangles)
+  Runner = connectedClosestPoints->begin();
+  Sprinter = Runner;
+  Sprinter++;
+  while (Sprinter != connectedClosestPoints->end()) {
+    DoLog(0) && (Log() << Verbose(0) << "Current Runner is " << *(*Runner) << " and sprinter is " << *(*Sprinter) << "." << endl);
+
+    AddTesselationPoint(TurningPoint, 0);
+    AddTesselationPoint(*Runner, 1);
+    AddTesselationPoint(*Sprinter, 2);
+
+    AddCandidateTriangle(CandidateLine, Opt);
+
+    Runner = Sprinter;
+    Sprinter++;
+    if (Sprinter != connectedClosestPoints->end()) {
+      // fill the internal open lines with its respective candidate (otherwise lines in degenerate case are not picked)
+      FindDegeneratedCandidatesforOpenLines(*Sprinter, &CandidateLine.OptCenter); // Assume BTS contains last triangle
+      DoLog(0) && (Log() << Verbose(0) << " There are still more triangles to add." << endl);
+    }
+    // pick candidates for other open lines as well
+    FindCandidatesforOpenLines(RADIUS, LC);
+
+    // check whether we add a degenerate or a normal triangle
+    if (CheckDegeneracy(CandidateLine, RADIUS, LC)) {
+      // add normal and degenerate triangles
+      DoLog(1) && (Log() << Verbose(1) << "Triangle of endpoints " << *TPS[0] << "," << *TPS[1] << " and " << *TPS[2] << " is degenerated, adding both sides." << endl);
+      AddCandidateTriangle(CandidateLine, OtherOpt);
+
+      if (Sprinter != connectedClosestPoints->end()) {
+        // fill the internal open lines with its respective candidate (otherwise lines in degenerate case are not picked)
+        FindDegeneratedCandidatesforOpenLines(*Sprinter, &CandidateLine.OtherOptCenter);
       }
-    } else if ((existentTrianglesCount >= 1) && (existentTrianglesCount <= 3)) { // If there is a planar region within the structure, we need this triangle a second time.
-        AddTesselationPoint((*it)->point, 0);
-        AddTesselationPoint(BaseRay->endpoints[0]->node, 1);
-        AddTesselationPoint(BaseRay->endpoints[1]->node, 2);
-
-        // We demand that at most one new degenerate line is created and that this line also already exists (which has to be the case due to existentTrianglesCount == 1)
-        // i.e. at least one of the three lines must be present with TriangleCount <= 1
-        if (CheckLineCriteriaForDegeneratedTriangle((const BoundaryPointSet ** const)TPS)) {
-          AddTesselationLine(TPS[0], TPS[1], 0);
-          AddTesselationLine(TPS[0], TPS[2], 1);
-          AddTesselationLine(TPS[1], TPS[2], 2);
-
-          BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
-          AddTesselationTriangle();  // add to global map
-
-          (*it)->OtherOptCenter.Scale(-1.);
-          BTS->GetNormalVector((*it)->OtherOptCenter);
-          (*it)->OtherOptCenter.Scale(-1.);
-
-          Log() << Verbose(0) << "--> WARNING: Special new triangle with " << *BTS << " and normal vector " << BTS->NormalVector
-          << " for this triangle ... " << endl;
-          Log() << Verbose(1) << "We have "<< BaseRay->triangles.size() << " for line " << BaseRay << "." << endl;
-        } else {
-          Log() << Verbose(1) << "WARNING: This triangle consisting of ";
-          Log() << Verbose(0) << *(*it)->point << ", ";
-          Log() << Verbose(0) << *BaseRay->endpoints[0]->node << " and ";
-          Log() << Verbose(0) << *BaseRay->endpoints[1]->node << " ";
-          Log() << Verbose(0) << "exists and is not added, as it does not seem helpful!" << endl;
-          result = false;
-        }
-    } else {
-      Log() << Verbose(1) << "This triangle consisting of ";
-      Log() << Verbose(0) << *(*it)->point << ", ";
-      Log() << Verbose(0) << *BaseRay->endpoints[0]->node << " and ";
-      Log() << Verbose(0) << *BaseRay->endpoints[1]->node << " ";
-      Log() << Verbose(0) << "is invalid!" << endl;
-      result = false;
-    }
-
-    // set baseline to new ray from ref point (here endpoints[0]->node) to current candidate (here (*it)->point))
-    BaseRay = BLS[0];
-    if ((BTS != NULL) && (BTS->NormalVector.NormSquared() < MYEPSILON)) {
-      Log() << Verbose(1) << "CRITICAL: Triangle " << *BTS << " has zero normal vector!" << endl;
-      exit(255);
-    }
-
-  }
-
-  // remove all candidates from the list and then the list itself
-  class CandidateForTesselation *remover = NULL;
-  for (CandidateList::iterator it = OptCandidates->begin(); it != OptCandidates->end(); ++it) {
-    remover = *it;
-    delete(remover);
-  }
-  delete(OptCandidates);
-  Log() << Verbose(0) << "End of FindNextSuitableTriangle\n";
-  return result;
+      // pick candidates for other open lines as well
+      FindCandidatesforOpenLines(RADIUS, LC);
+    }
+  }
+  delete (connectedClosestPoints);
 };
+
+/** for polygons (multiple candidates for a baseline) sets internal edges to the correct next candidate.
+ * \param *Sprinter next candidate to which internal open lines are set
+ * \param *OptCenter OptCenter for this candidate
+ */
+void Tesselation::FindDegeneratedCandidatesforOpenLines(TesselPoint * const Sprinter, const Vector * const OptCenter)
+{
+  Info FunctionInfo(__func__);
+
+  pair<LineMap::iterator, LineMap::iterator> FindPair = TPS[0]->lines.equal_range(TPS[2]->node->nr);
+  for (LineMap::const_iterator FindLine = FindPair.first; FindLine != FindPair.second; FindLine++) {
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Checking line " << *(FindLine->second) << " ..." << endl);
+    // If there is a line with less than two attached triangles, we don't need a new line.
+    if (FindLine->second->triangles.size() == 1) {
+      CandidateMap::iterator Finder = OpenLines.find(FindLine->second);
+      if (!Finder->second->pointlist.empty())
+        DoLog(1) && (Log() << Verbose(1) << "INFO: line " << *(FindLine->second) << " is open with candidate " << **(Finder->second->pointlist.begin()) << "." << endl);
+      else {
+        DoLog(1) && (Log() << Verbose(1) << "INFO: line " << *(FindLine->second) << " is open with no candidate, setting to next Sprinter" << (*Sprinter) << endl);
+        Finder->second->T = BTS;  // is last triangle
+        Finder->second->pointlist.push_back(Sprinter);
+        Finder->second->ShortestAngle = 0.;
+        Finder->second->OptCenter.CopyVector(OptCenter);
+      }
+    }
+  }
+};
+
+/** If a given \a *triangle is degenerated, this adds both sides.
+ * i.e. the triangle with same BoundaryPointSet's but NormalVector in opposite direction.
+ * Note that endpoints are stored in Tesselation::TPS
+ * \param CandidateLine CanddiateForTesselation structure for the desired BoundaryLine
+ * \param RADIUS radius of sphere
+ * \param *LC pointer to LinkedCell structure
+ */
+void Tesselation::AddDegeneratedTriangle(CandidateForTesselation &CandidateLine, const double RADIUS, const LinkedCell *LC)
+{
+  Info FunctionInfo(__func__);
+  Vector Center;
+  CandidateMap::const_iterator CandidateCheck = OpenLines.end();
+  BoundaryTriangleSet *triangle = NULL;
+
+  /// 1. Create or pick the lines for the first triangle
+  DoLog(0) && (Log() << Verbose(0) << "INFO: Creating/Picking lines for first triangle ..." << endl);
+  for (int i = 0; i < 3; i++) {
+    BLS[i] = NULL;
+    DoLog(0) && (Log() << Verbose(0) << "Current line is between " << *TPS[(i + 0) % 3] << " and " << *TPS[(i + 1) % 3] << ":" << endl);
+    AddTesselationLine(&CandidateLine.OptCenter, TPS[(i + 2) % 3], TPS[(i + 0) % 3], TPS[(i + 1) % 3], i);
+  }
+
+  /// 2. create the first triangle and NormalVector and so on
+  DoLog(0) && (Log() << Verbose(0) << "INFO: Adding first triangle with center at " << CandidateLine.OptCenter << " ..." << endl);
+  BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
+  AddTesselationTriangle();
+
+  // create normal vector
+  BTS->GetCenter(&Center);
+  Center.SubtractVector(&CandidateLine.OptCenter);
+  BTS->SphereCenter.CopyVector(&CandidateLine.OptCenter);
+  BTS->GetNormalVector(Center);
+  // give some verbose output about the whole procedure
+  if (CandidateLine.T != NULL)
+    DoLog(0) && (Log() << Verbose(0) << "--> New triangle with " << *BTS << " and normal vector " << BTS->NormalVector << ", from " << *CandidateLine.T << " and angle " << CandidateLine.ShortestAngle << "." << endl);
+  else
+    DoLog(0) && (Log() << Verbose(0) << "--> New starting triangle with " << *BTS << " and normal vector " << BTS->NormalVector << " and no top triangle." << endl);
+  triangle = BTS;
+
+  /// 3. Gather candidates for each new line
+  DoLog(0) && (Log() << Verbose(0) << "INFO: Adding candidates to new lines ..." << endl);
+  for (int i = 0; i < 3; i++) {
+    DoLog(0) && (Log() << Verbose(0) << "Current line is between " << *TPS[(i + 0) % 3] << " and " << *TPS[(i + 1) % 3] << ":" << endl);
+    CandidateCheck = OpenLines.find(BLS[i]);
+    if ((CandidateCheck != OpenLines.end()) && (CandidateCheck->second->pointlist.empty())) {
+      if (CandidateCheck->second->T == NULL)
+        CandidateCheck->second->T = triangle;
+      FindNextSuitableTriangle(*(CandidateCheck->second), *CandidateCheck->second->T, RADIUS, LC);
+    }
+  }
+
+  /// 4. Create or pick the lines for the second triangle
+  DoLog(0) && (Log() << Verbose(0) << "INFO: Creating/Picking lines for second triangle ..." << endl);
+  for (int i = 0; i < 3; i++) {
+    DoLog(0) && (Log() << Verbose(0) << "Current line is between " << *TPS[(i + 0) % 3] << " and " << *TPS[(i + 1) % 3] << ":" << endl);
+    AddTesselationLine(&CandidateLine.OtherOptCenter, TPS[(i + 2) % 3], TPS[(i + 0) % 3], TPS[(i + 1) % 3], i);
+  }
+
+  /// 5. create the second triangle and NormalVector and so on
+  DoLog(0) && (Log() << Verbose(0) << "INFO: Adding second triangle with center at " << CandidateLine.OtherOptCenter << " ..." << endl);
+  BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
+  AddTesselationTriangle();
+
+  BTS->SphereCenter.CopyVector(&CandidateLine.OtherOptCenter);
+  // create normal vector in other direction
+  BTS->GetNormalVector(&triangle->NormalVector);
+  BTS->NormalVector.Scale(-1.);
+  // give some verbose output about the whole procedure
+  if (CandidateLine.T != NULL)
+    DoLog(0) && (Log() << Verbose(0) << "--> New degenerate triangle with " << *BTS << " and normal vector " << BTS->NormalVector << ", from " << *CandidateLine.T << " and angle " << CandidateLine.ShortestAngle << "." << endl);
+  else
+    DoLog(0) && (Log() << Verbose(0) << "--> New degenerate starting triangle with " << *BTS << " and normal vector " << BTS->NormalVector << " and no top triangle." << endl);
+
+  /// 6. Adding triangle to new lines
+  DoLog(0) && (Log() << Verbose(0) << "INFO: Adding second triangles to new lines ..." << endl);
+  for (int i = 0; i < 3; i++) {
+    DoLog(0) && (Log() << Verbose(0) << "Current line is between " << *TPS[(i + 0) % 3] << " and " << *TPS[(i + 1) % 3] << ":" << endl);
+    CandidateCheck = OpenLines.find(BLS[i]);
+    if ((CandidateCheck != OpenLines.end()) && (CandidateCheck->second->pointlist.empty())) {
+      if (CandidateCheck->second->T == NULL)
+        CandidateCheck->second->T = BTS;
+    }
+  }
+}
+;
+
+/** Adds a triangle to the Tesselation structure from three given TesselPoint's.
+ * Note that endpoints are in Tesselation::TPS.
+ * \param CandidateLine CandidateForTesselation structure contains other information
+ * \param type which opt center to add (i.e. which side) and thus which NormalVector to take
+ */
+void Tesselation::AddCandidateTriangle(CandidateForTesselation &CandidateLine, enum centers type)
+{
+  Info FunctionInfo(__func__);
+  Vector Center;
+  Vector *OptCenter = (type == Opt) ? &CandidateLine.OptCenter : &CandidateLine.OtherOptCenter;
+
+  // add the lines
+  AddTesselationLine(OptCenter, TPS[2], TPS[0], TPS[1], 0);
+  AddTesselationLine(OptCenter, TPS[1], TPS[0], TPS[2], 1);
+  AddTesselationLine(OptCenter, TPS[0], TPS[1], TPS[2], 2);
+
+  // add the triangles
+  BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
+  AddTesselationTriangle();
+
+  // create normal vector
+  BTS->GetCenter(&Center);
+  Center.SubtractVector(OptCenter);
+  BTS->SphereCenter.CopyVector(OptCenter);
+  BTS->GetNormalVector(Center);
+
+  // give some verbose output about the whole procedure
+  if (CandidateLine.T != NULL)
+    DoLog(0) && (Log() << Verbose(0) << "--> New" << ((type == OtherOpt) ? " degenerate " : " ") << "triangle with " << *BTS << " and normal vector " << BTS->NormalVector << ", from " << *CandidateLine.T << " and angle " << CandidateLine.ShortestAngle << "." << endl);
+  else
+    DoLog(0) && (Log() << Verbose(0) << "--> New" << ((type == OtherOpt) ? " degenerate " : " ") << "starting triangle with " << *BTS << " and normal vector " << BTS->NormalVector << " and no top triangle." << endl);
+}
+;
 
 /** Checks whether the quadragon of the two triangles connect to \a *Base is convex.
@@ -1896,17 +2778,18 @@
 class BoundaryPointSet *Tesselation::IsConvexRectangle(class BoundaryLineSet *Base)
 {
+  Info FunctionInfo(__func__);
   class BoundaryPointSet *Spot = NULL;
   class BoundaryLineSet *OtherBase;
   Vector *ClosestPoint;
 
-  int m=0;
-  for(TriangleMap::iterator runner = Base->triangles.begin(); runner != Base->triangles.end(); runner++)
-    for (int j=0;j<3;j++) // all of their endpoints and baselines
+  int m = 0;
+  for (TriangleMap::iterator runner = Base->triangles.begin(); runner != Base->triangles.end(); runner++)
+    for (int j = 0; j < 3; j++) // all of their endpoints and baselines
       if (!Base->ContainsBoundaryPoint(runner->second->endpoints[j])) // and neither of its endpoints
         BPS[m++] = runner->second->endpoints[j];
-  OtherBase = new class BoundaryLineSet(BPS,-1);
-
-  Log() << Verbose(3) << "INFO: Current base line is " << *Base << "." << endl;
-  Log() << Verbose(3) << "INFO: Other base line is " << *OtherBase << "." << endl;
+  OtherBase = new class BoundaryLineSet(BPS, -1);
+
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Current base line is " << *Base << "." << endl);
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Other base line is " << *OtherBase << "." << endl);
 
   // get the closest point on each line to the other line
@@ -1914,5 +2797,5 @@
 
   // delete the temporary other base line
-  delete(OtherBase);
+  delete (OtherBase);
 
   // get the distance vector from Base line to OtherBase line
@@ -1921,12 +2804,12 @@
   BaseLine.CopyVector(Base->endpoints[1]->node->node);
   BaseLine.SubtractVector(Base->endpoints[0]->node->node);
-  for (int i=0;i<2;i++) {
+  for (int i = 0; i < 2; i++) {
     DistanceToIntersection[i].CopyVector(ClosestPoint);
     DistanceToIntersection[i].SubtractVector(Base->endpoints[i]->node->node);
     distance[i] = BaseLine.ScalarProduct(&DistanceToIntersection[i]);
   }
-  delete(ClosestPoint);
-  if ((distance[0] * distance[1]) > 0)  { // have same sign?
-    Log() << Verbose(3) << "REJECT: Both SKPs have same sign: " << distance[0] << " and " << distance[1]  << ". " << *Base << "' rectangle is concave." << endl;
+  delete (ClosestPoint);
+  if ((distance[0] * distance[1]) > 0) { // have same sign?
+    DoLog(1) && (Log() << Verbose(1) << "REJECT: Both SKPs have same sign: " << distance[0] << " and " << distance[1] << ". " << *Base << "' rectangle is concave." << endl);
     if (distance[0] < distance[1]) {
       Spot = Base->endpoints[0];
@@ -1935,34 +2818,41 @@
     }
     return Spot;
-  } else {  // different sign, i.e. we are in between
-    Log() << Verbose(3) << "ACCEPT: Rectangle of triangles of base line " << *Base << " is convex." << endl;
+  } else { // different sign, i.e. we are in between
+    DoLog(0) && (Log() << Verbose(0) << "ACCEPT: Rectangle of triangles of base line " << *Base << " is convex." << endl);
     return NULL;
   }
 
-};
+}
+;
 
 void Tesselation::PrintAllBoundaryPoints(ofstream *out) const
 {
+  Info FunctionInfo(__func__);
   // print all lines
-  Log() << Verbose(1) << "Printing all boundary points for debugging:" << endl;
-  for (PointMap::const_iterator PointRunner = PointsOnBoundary.begin();PointRunner != PointsOnBoundary.end(); PointRunner++)
-    Log() << Verbose(2) << *(PointRunner->second) << endl;
-};
+  DoLog(0) && (Log() << Verbose(0) << "Printing all boundary points for debugging:" << endl);
+  for (PointMap::const_iterator PointRunner = PointsOnBoundary.begin(); PointRunner != PointsOnBoundary.end(); PointRunner++)
+    DoLog(0) && (Log() << Verbose(0) << *(PointRunner->second) << endl);
+}
+;
 
 void Tesselation::PrintAllBoundaryLines(ofstream *out) const
 {
+  Info FunctionInfo(__func__);
   // print all lines
-  Log() << Verbose(1) << "Printing all boundary lines for debugging:" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Printing all boundary lines for debugging:" << endl);
   for (LineMap::const_iterator LineRunner = LinesOnBoundary.begin(); LineRunner != LinesOnBoundary.end(); LineRunner++)
-    Log() << Verbose(2) << *(LineRunner->second) << endl;
-};
+    DoLog(0) && (Log() << Verbose(0) << *(LineRunner->second) << endl);
+}
+;
 
 void Tesselation::PrintAllBoundaryTriangles(ofstream *out) const
 {
+  Info FunctionInfo(__func__);
   // print all triangles
-  Log() << Verbose(1) << "Printing all boundary triangles for debugging:" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Printing all boundary triangles for debugging:" << endl);
   for (TriangleMap::const_iterator TriangleRunner = TrianglesOnBoundary.begin(); TriangleRunner != TrianglesOnBoundary.end(); TriangleRunner++)
-    Log() << Verbose(2) << *(TriangleRunner->second) << endl;
-};
+    DoLog(0) && (Log() << Verbose(0) << *(TriangleRunner->second) << endl);
+}
+;
 
 /** For a given boundary line \a *Base and its two triangles, picks the central baseline that is "higher".
@@ -1973,17 +2863,18 @@
 double Tesselation::PickFarthestofTwoBaselines(class BoundaryLineSet *Base)
 {
+  Info FunctionInfo(__func__);
   class BoundaryLineSet *OtherBase;
   Vector *ClosestPoint[2];
   double volume;
 
-  int m=0;
-  for(TriangleMap::iterator runner = Base->triangles.begin(); runner != Base->triangles.end(); runner++)
-    for (int j=0;j<3;j++) // all of their endpoints and baselines
+  int m = 0;
+  for (TriangleMap::iterator runner = Base->triangles.begin(); runner != Base->triangles.end(); runner++)
+    for (int j = 0; j < 3; j++) // all of their endpoints and baselines
       if (!Base->ContainsBoundaryPoint(runner->second->endpoints[j])) // and neither of its endpoints
         BPS[m++] = runner->second->endpoints[j];
-  OtherBase = new class BoundaryLineSet(BPS,-1);
-
-  Log() << Verbose(3) << "INFO: Current base line is " << *Base << "." << endl;
-  Log() << Verbose(3) << "INFO: Other base line is " << *OtherBase << "." << endl;
+  OtherBase = new class BoundaryLineSet(BPS, -1);
+
+  DoLog(0) && (Log() << Verbose(0) << "INFO: Current base line is " << *Base << "." << endl);
+  DoLog(0) && (Log() << Verbose(0) << "INFO: Other base line is " << *OtherBase << "." << endl);
 
   // get the closest point on each line to the other line
@@ -2000,10 +2891,10 @@
 
   // delete the temporary other base line and the closest points
-  delete(ClosestPoint[0]);
-  delete(ClosestPoint[1]);
-  delete(OtherBase);
+  delete (ClosestPoint[0]);
+  delete (ClosestPoint[1]);
+  delete (OtherBase);
 
   if (Distance.NormSquared() < MYEPSILON) { // check for intersection
-    Log() << Verbose(3) << "REJECT: Both lines have an intersection: Nothing to do." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "REJECT: Both lines have an intersection: Nothing to do." << endl);
     return false;
   } else { // check for sign against BaseLineNormal
